<?php

class Onpay_Onpay_PaymentController extends Mage_Core_Controller_Front_Action
{
  protected $_order;

  public function redirectAction()
  {
    $session = $this->getSession();
    $quote_id = $session->getQuoteId();
    $last_real_order_id = $session->getLastRealOrderId();
    
    if (is_null($quote_id) || is_null($last_real_order_id)) {
            $this->_redirect('checkout/cart/');
        } else {
            $session->setOnpayQuoteId($quote_id);
            $session->setOnpayLastRealOrderId($last_real_order_id);
            $order = $this->getOrder();
            $order->loadByIncrementId($last_real_order_id);
            $html = $this->getLayout()->createBlock('onpay/redirect')->toHtml();
            
            $this->getResponse()->setHeader('Content-type', 'text/html; charset=windows-1251')->setBody($html);
            
            $session->getQuote()->setIsActive(false)->save();
            $session->setQuoteId(null);
            $session->setLastRealOrderId(null);
        }
  }
  
  public function resultAction()
  {
    $this->getOnpay()->processNotification();
  }
  
  public function getSession()
    {
        return Mage::getSingleton('checkout/session');
    }
 
    public function getOrder()
    {
        if ($this->_order == null) {
            $session = $this->getSession();
            $this->_order = Mage::getModel('sales/order');
            $this->_order->loadByIncrementId($session->getLastRealOrderId());
        }
        return $this->_order;
    }

    public function getOnpay()
    {
        return Mage::getSingleton('onpay/paymentMethod');
    }

}